/* ---------------------------------------------------------- 
%   (C)1994, 1995 Institute for New Generation Computer Technology 
%       (Read COPYRIGHT for detailed information.) 
%   (C)1996, 1997, 1998, 1999 Japan Information Processing Development Center
%       (Read COPYRIGHT-JIPDEC for detailed information.)
----------------------------------------------------------- */

#ifndef _KLIC_ASYNCIO_H_
#define _KLIC_ASYNCIO_H_

#include <sys/types.h>  /* fd_set */

enum sigiotype {
  KLIC_SIGIO_NONE,
  KLIC_SIGIO_IN,
  KLIC_SIGIO_OUT,
  KLIC_SIGIO_INOUT
};

typedef int (*sigio_t)(long fd, enum sigiotype, fd_set* rfd, fd_set* wfd);

/* runtime/asyncio.c */
extern void add_sigio_handler(long fd, sigio_t func, enum sigiotype sigio_type);
extern void init_sigio_handler(void);
extern void init_asynchronous_io(void);
extern void close_asynchronous_io_stream(long fd);
extern void register_asynchronous_io_stream(long fd, q stream);
extern int poll_read_available(int fd);

#endif /* _KLIC_ASYNCIO_H_ */
